#include <gtk/gtk.h>
#include <stdio.h>
#include <mysql/mysql.h>
#include <stdlib.h>
#include <string.h>
#include "main.h"

/* define variabele */
MYSQL *mysql_handle = NULL,  *mysql_handle_result = NULL;
int ncol = 0; /* the number of column's .. could be handy to know */

void add_category_add_but(GtkWidget *button, GtkListStore *list);
void add_category_remove_but(GtkWidget *button, trees *as);
void add_sub_category_edit(GtkCellRendererText *cell, const char *path_string, const char *new_text, trees *as);
void tree_edited_string(GtkCellRendererText *cell, const char *path_string, const char *new_text, gpointer i);
void tree_edited_int(GtkCellRendererText *cell, const char *path_string, const char *new_text, gpointer i);
void empty_option_menu(GtkWidget **items);
void fixed_toggled (GtkCellRendererToggle *cell, gchar *path_str, gpointer data);
int add_sub_toggled_string (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data);
int add_sub_toggled_int (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data);
int add_sub_toggled_bool (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data);

int index_changed_test(GtkTreeSelection *selection){
    GtkTreeIter iter;
    GtkCellRenderer *renderer;
    GtkListStore *temp;
    int i, value, n;
    gchar *name;
    
    empty_option_menu(qs_sel);    

    gtk_widget_show_all(qs_option);
    if(mysql_handle == NULL) return TRUE;

    /* empty columns  and set firt to NULL*/
    for(i=0; main_win.table.columns[i] != NULL; i++) gtk_tree_view_remove_column(GTK_TREE_VIEW(main_win.table.treeview), main_win.table.columns[i]);
	main_win.table.columns = g_realloc(main_win.table.columns, sizeof(GtkTreeViewColumn));
	main_win.table.columns[0] = NULL;
	ncol = 0;

    
	/* test if it is a selectable item. (so no dbase) */
	if(gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter))
	{
	    gtk_tree_model_get(main_win.index.model, &iter,0, &name,  1, &value, -1);
	if(value == 0)
	    {
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/New"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Edit"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Delete"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/New"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Edit"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Delete"), FALSE);    
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Empty"), FALSE);    
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/New"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/Delete"), FALSE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, FALSE);    	
	    }
	else if(value == 1)
	    {
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/New"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Edit"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Delete"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/New"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Edit"), TRUE);    
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Delete"), TRUE);    
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Empty"), TRUE);    
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/New"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/Delete"), TRUE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, TRUE);    		    
	    }
	else if(value == 2)
	    {
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/New"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Edit"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Delete"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/New"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Edit"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Delete"), FALSE);
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Empty"), FALSE);    	    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/New"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/Delete"), FALSE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, FALSE);    		
	    }
	else if(value == 3){
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/New"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Edit"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Delete"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/New"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Edit"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Delete"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Empty"), FALSE); 
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/New"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/Delete"), FALSE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, FALSE);    	
	    }	
	
	
	    if(value == 1){ 
	    MYSQL_ROW mysql_row;
	    MYSQL_RES *mysql_result = NULL;
	    char query[256];
	    int i;
	    /* get the column name's, (and number of columns) */
	    sprintf(query, "describe `%s`", name);
	    if(mysql_query(mysql_handle, query))
		{
		    error_dialog(mysql_error(mysql_handle));
		    return TRUE;
		}	
	    if(!(mysql_result = mysql_store_result(mysql_handle)))
		{
		    error_dialog(mysql_error(mysql_handle));
		    return TRUE;
		}
	    n = mysql_num_rows(mysql_result);
	    
	    

	    main_win.table.types = g_realloc(main_win.table.types, (n+1)*sizeof(GType));
	    i = 0;
	    while ((mysql_row = mysql_fetch_row (mysql_result))){
		if(!strncasecmp(mysql_row[1], "tinyint(1)", 10)) main_win.table.types[i] = G_TYPE_BOOLEAN;
		else if(!strncasecmp(mysql_row[1], "int(", 4)) main_win.table.types[i] = G_TYPE_INT;
//		else if(!strncasecmp(mysql_row[1], "longtext", 8))
		else main_win.table.types[i] = G_TYPE_STRING;
		 i++;
	    }
	    main_win.table.types[n] = G_TYPE_BOOLEAN;
	    temp = gtk_list_store_newv(n+1, main_win.table.types);

	    gtk_list_store_clear(main_win.table.liststore);
	    gtk_tree_view_set_model(GTK_TREE_VIEW(main_win.table.treeview),  GTK_TREE_MODEL(temp));
	    g_object_unref(G_OBJECT(main_win.table.liststore));
	    main_win.table.liststore = temp;

	    main_win.table.model = GTK_TREE_MODEL(main_win.table.liststore);

	    mysql_free_result(mysql_result);
	    /* fixme.. dont get it again.. use old result */
	    if(mysql_query(mysql_handle, query))
		{
		    error_dialog(mysql_error(mysql_handle));
		    return TRUE;
		}	
	    if(!(mysql_result = mysql_store_result(mysql_handle)))
		{
		    error_dialog(mysql_error(mysql_handle));
		    return TRUE;
		}
	    
	    
	    while ((mysql_row = mysql_fetch_row (mysql_result)))
		{
		if(ncol != 0){
		    main_win.table.columns = g_realloc(main_win.table.columns, (ncol+2)*sizeof(GtkTreeViewColumn));
		     main_win.table.columns[ncol+1] = NULL;

		     if(main_win.table.types[ncol] == G_TYPE_STRING){
		    	renderer = gtk_cell_renderer_text_new();     
		    	main_win.table.columns[ncol] = gtk_tree_view_column_new_with_attributes(mysql_row[0], renderer, "text",ncol, "editable", n, NULL);
		        g_signal_connect(G_OBJECT(renderer), "edited", G_CALLBACK(tree_edited_string), GINT_TO_POINTER(ncol));		
			gtk_tree_view_column_set_sort_column_id (main_win.table.columns[ncol], ncol);
			 }
		     else if(main_win.table.types[ncol] == G_TYPE_INT){
		    	renderer = gtk_cell_renderer_text_new();     
		    	main_win.table.columns[ncol] = gtk_tree_view_column_new_with_attributes(mysql_row[0], renderer, "text",ncol, "editable", n, NULL);
		        g_signal_connect(G_OBJECT(renderer), "edited", G_CALLBACK(tree_edited_int), GINT_TO_POINTER(ncol));		
			gtk_tree_view_column_set_sort_column_id (main_win.table.columns[ncol], ncol);
			 }
		

		     else{
	      		renderer = gtk_cell_renderer_toggle_new(); 
		        main_win.table.columns[ncol] = gtk_tree_view_column_new_with_attributes(mysql_row[0], renderer, "active",ncol, NULL);
			g_signal_connect_after (renderer, "toggled",G_CALLBACK (fixed_toggled), GINT_TO_POINTER(ncol));
		        }  
		       
		
		    /* update the quick search selector */
    		    qs_sel = g_realloc(qs_sel, (ncol + 2) * sizeof(GtkWidget));
	    	    qs_sel[ncol-1] = gtk_menu_item_new_with_label (mysql_row[0]);
		    qs_sel[ncol] = NULL;
    		    gtk_menu_shell_append (GTK_MENU_SHELL (qs_menu), qs_sel[ncol-1]);
		}
		else{
		renderer = gtk_cell_renderer_text_new();
		main_win.table.columns = g_realloc(main_win.table.columns, (ncol+2)*sizeof(GtkTreeViewColumn));
		 main_win.table.columns[ncol] = gtk_tree_view_column_new_with_attributes(mysql_row[0], renderer, "text",ncol, NULL);
		 main_win.table.columns[ncol+1] = NULL;
		gtk_tree_view_column_set_sort_column_id (main_win.table.columns[ncol], ncol);
		}
		gtk_tree_view_append_column(GTK_TREE_VIEW(main_win.table.treeview), main_win.table.columns[ncol]);

		ncol++;
		}
	    /* more quicksearch stuff */
	    gtk_option_menu_set_history(GTK_OPTION_MENU(qs_option), 0);
	    gtk_widget_show_all(qs_option);
//	    main_win.table.columns[ncol] = NULL;
	    mysql_free_result(mysql_result);
	    
	    load_table(name, NULL);
	    }
	}
	else{
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/New"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Delete"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Edit"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/New"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Edit"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Delete"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Empty"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/New"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/Delete"), FALSE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, FALSE);    	
	}
	
    return FALSE;
    }


void load_table(char *name, const char *search)
    {
    MYSQL_ROW mysql_row;
    MYSQL_RES *mysql_result = NULL;
    GtkTreeIter iter;
    GString *query = g_string_new("");
    int i;
    /* empty the clist.. */
    gtk_list_store_clear(main_win.table.liststore);

    if(search == NULL) g_string_printf(query, "select * from `%s`", name);        
    else  g_string_printf(query, "select * from `%s` WHERE `%s` LIKE \"%%%s%%\"", 
		name, 
		gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[gtk_option_menu_get_history(GTK_OPTION_MENU(qs_option))+1])),
		search);      
		
    if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
    if(!(mysql_result = mysql_use_result(mysql_handle))){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}
    while ((mysql_row = mysql_fetch_row (mysql_result))){
	gtk_widget_show(main_win.progress);
	gtk_list_store_append(main_win.table.liststore, &iter);
	gtk_list_store_set(main_win.table.liststore, &iter, 0, atoi(mysql_row[0]), -1);

    for(i=1; i< ncol+1; i++)
	    {
	    if(main_win.table.types[i] == G_TYPE_BOOLEAN){
		/* cant I just cast it.. (doesnt seems to work) look at this */
		 if(atoi(mysql_row[i]) == 1) gtk_list_store_set(main_win.table.liststore, &iter, i,TRUE , -1);
		 else gtk_list_store_set(main_win.table.liststore, &iter, i,FALSE , -1);
		 
		 }
	    else if(main_win.table.types[i] == G_TYPE_INT){
	     gtk_list_store_set(main_win.table.liststore, &iter, i, atoi(mysql_row[i]), -1);
	    }
	    else gtk_list_store_set(main_win.table.liststore, &iter, i, mysql_row[i], -1);
	    }
	    gtk_list_store_set(main_win.table.liststore, &iter, ncol, 1, -1);
	}

    mysql_free_result(mysql_result);
    g_string_free(query, TRUE);
}






void connect_to_dbase(){
    /* check if allready connected */
  if (mysql_handle_result != NULL)
    {
	return;
    }
    gtk_tree_store_clear(main_win.index.treestore);
    /* start the mysql intialising */
  mysql_handle = mysql_init (mysql_handle);
  if (!mysql_handle) /* check if succesfull. */
    {
	error_dialog(mysql_error(mysql_handle));
	return;
    }
  mysql_handle_result = mysql_real_connect (mysql_handle, main_info.hostname, main_info.username,main_info.password,main_info.database, 0, NULL,0);
  if (!mysql_handle_result)
    {
	error_dialog(mysql_error(mysql_handle));
      return;
    }

    /* set some sensitive stuff :) yeah I know bad word pun */
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Connect"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Disconnect"), TRUE);
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Import table"), TRUE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Export table"), TRUE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category"), TRUE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category"), TRUE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item"), TRUE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, FALSE);    	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/New"), TRUE);    	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Edit"), FALSE);    	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category/Delete"), FALSE);    	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/New"), FALSE);    	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Edit"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category/Delete"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/New"), FALSE);    	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item/Delete"), FALSE);    


    load_index_tree();
}


void load_index_tree(){
    MYSQL_ROW mysql_row;
    MYSQL_RES *mysql_result;
    GtkTreeIter iter;
    GtkTreeIter child_iter;
    char string[256];
    gtk_tree_store_clear(main_win.index.treestore);

    sprintf(string, "select * from `dbase`");

    if(mysql_query(mysql_handle, string)){
	if(mysql_errno(mysql_handle) == 1146){
	    /* there is no dbase */
	    if(mysql_query(mysql_handle, "CREATE TABLE `dbase` (`type` VARCHAR(128) NULL)")){
		error_dialog(mysql_error(mysql_handle));
		return;
	    }
	    else{
	    load_index_tree();
	    return;
	    }
	}
	error_dialog(mysql_error(mysql_handle));
	return;
    }	
    if(!(mysql_result = mysql_use_result(mysql_handle))){
	error_dialog(mysql_error(mysql_handle));
	return;
    }
    	
    while((mysql_row = mysql_fetch_row (mysql_result)))
	{
	gtk_tree_store_append (main_win.index.treestore, &iter, NULL);
	gtk_tree_store_set (main_win.index.treestore, &iter,0, mysql_row[0], 1, 0, -1);
	}
    mysql_free_result(mysql_result);
    
    
    
    if(gtk_tree_model_get_iter_first(main_win.index.model, &iter))
    do{
	gchar *name;
	gtk_tree_model_get(main_win.index.model, &iter, 0, &name, -1);
	/* get the childs */
	sprintf(string, "select * from `%s`", name);
        if(mysql_query(mysql_handle, string)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	    }	
	if(!(mysql_result = mysql_use_result(mysql_handle))){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	    }
        while((mysql_row = mysql_fetch_row(mysql_result))){
		gtk_tree_store_append (main_win.index.treestore, &child_iter, &iter);
		gtk_tree_store_set (main_win.index.treestore, &child_iter,0, mysql_row[0],1, 1, -1);
		}
	gtk_tree_store_append (main_win.index.treestore, &child_iter, &iter);
	gtk_tree_store_set (main_win.index.treestore, &child_iter,0, "<add sub-category>",1, 3, -1);
	mysql_free_result(mysql_result);	    
    }while(gtk_tree_model_iter_next(main_win.index.model, &iter));
    gtk_tree_store_append (main_win.index.treestore, &iter, NULL);
    gtk_tree_store_set (main_win.index.treestore, &iter,0, "<add category>", 1, 2, -1);


    }


void quit_connection(){
    int i;
    
    mysql_close(mysql_handle);
    mysql_handle = NULL;
        
    /* FIXME: remove this useless piece of code */
    mysql_handle_result = NULL;
    
    /* empty the clist.. */
    gtk_list_store_clear(main_win.table.liststore);
    gtk_tree_store_clear(main_win.index.treestore);

    /* empty columns  and set firt to NULL*/
    for(i=0; i < 11 &&  main_win.table.columns[i] != NULL; i++) gtk_tree_view_remove_column(GTK_TREE_VIEW(main_win.table.treeview), main_win.table.columns[i]);
	main_win.table.columns[0] = NULL;
	ncol = 0;
    /* more top secret stuff */	
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Connect"), TRUE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Disconnect"), FALSE);
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Import table"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/File/Export table"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Category"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Sub category"), FALSE);    
    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.item_factory, "/Database/Item"), FALSE);    
    	    gtk_widget_set_sensitive(main_win.toolbar, FALSE);    	

}

void close_prefwin(GtkWidget *button, windows *pref_win){
    strncpy(main_info.hostname, gtk_entry_get_text(GTK_ENTRY(pref_win->server.entries[0])), 255);
    strncpy(main_info.username, gtk_entry_get_text(GTK_ENTRY(pref_win->server.entries[1])), 255);
    strncpy(main_info.password, gtk_entry_get_text(GTK_ENTRY(pref_win->server.entries[2])), 255);
    strncpy(main_info.database, gtk_entry_get_text(GTK_ENTRY(pref_win->server.entries[3])), 255);
    main_info.auto_connect = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pref_win->server.buttons[0]));
    main_info.save_settings = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pref_win->server.buttons[1]));
    main_info.save_posize = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pref_win->server.buttons[2]));    
    gtk_widget_destroy(pref_win->window);
    g_free(pref_win->server.labels);
    g_free(pref_win->server.entries);
    g_free(pref_win);
}


void handle_index_double_click_signal(){
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    int value;

    
    if(mysql_handle == NULL) return;

    
    /* check if there is a selection if yes then check if double clicked on add category */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	gtk_tree_model_get(main_win.index.model, &iter, 1, &value, -1);
	
	if(value == 3) add_sub_category();
    	else if(value == 2) add_a_category();
	else index_changed_test(selection);
    }    
}



void add_sub_category(){
    GtkWidget *dialog;
    GtkWidget *hbox, *label, *entry;
//    GtkListStore *as.list;
    GtkWidget *sw;
    GtkWidget *vbox, *add, *remove;
    GtkCellRenderer *renderer;
    GtkTreeSelection *selection;
    trees *as;
    int close = 0;
    GString *query = g_string_new("");    
    
    if(mysql_handle == NULL) return;
    as = g_malloc(sizeof(trees));    
    dialog = gtk_dialog_new_with_buttons("Add a Sub-Category", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_ADD, GTK_RESPONSE_ACCEPT,
		"Add and Close", GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
    gtk_widget_set_usize(GTK_WIDGET(dialog), 400, 350);
    hbox = gtk_hbox_new(FALSE, 6);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
    label = gtk_label_new("Sub-Category name:");
    entry = gtk_entry_new_with_max_length(255);
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), hbox, FALSE, TRUE,0);
    
    hbox = gtk_hbox_new(FALSE, 6);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
    sw = gtk_scrolled_window_new(NULL, NULL);
    as->liststore = gtk_list_store_new(6, G_TYPE_INT,G_TYPE_STRING, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
    as->treeview = gtk_tree_view_new_with_model( GTK_TREE_MODEL(as->liststore));
    gtk_box_pack_start(GTK_BOX(hbox), sw, TRUE, TRUE, 0);    
    gtk_container_add(GTK_CONTAINER(sw), as->treeview);

    renderer = gtk_cell_renderer_text_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "Column name", renderer, "text",1, "editable", 5, NULL);
    g_signal_connect(G_OBJECT(renderer), "edited", G_CALLBACK(add_sub_category_edit), as);

    renderer = gtk_cell_renderer_toggle_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "String", renderer, "active",2, NULL);
    g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(add_sub_toggled_string), GTK_TREE_MODEL(as->liststore));

    renderer = gtk_cell_renderer_toggle_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "Integer", renderer, "active",3, NULL);
    g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(add_sub_toggled_int), GTK_TREE_MODEL(as->liststore));

    renderer = gtk_cell_renderer_toggle_new ();
    gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (as->treeview),-1, "Boolean", renderer, "active",4, NULL);
    g_signal_connect(G_OBJECT(renderer), "toggled", G_CALLBACK(add_sub_toggled_bool), GTK_TREE_MODEL(as->liststore));


    vbox = gtk_vbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, TRUE, 0);
    add = gtk_button_new_from_stock(GTK_STOCK_ADD);
    remove = gtk_button_new_from_stock(GTK_STOCK_DELETE);
    gtk_box_pack_start(GTK_BOX(vbox), add, FALSE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), remove, FALSE, TRUE, 0);

    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), hbox, TRUE, TRUE,0);        
    gtk_widget_show_all(GTK_WIDGET(GTK_DIALOG(dialog)->vbox));
    
    /* signals */
    g_signal_connect(G_OBJECT(add), "clicked", G_CALLBACK(add_category_add_but), as->liststore);
    g_signal_connect(G_OBJECT(remove), "clicked", G_CALLBACK(add_category_remove_but), as);
    
    while(!close){
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_OK:
	    close = 1;
	case GTK_RESPONSE_ACCEPT:
	    {
	    GtkTreeIter iter, parentiter;
	    char *name;
	    gint string, intg, bo;
	    int i, numr = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(as->liststore), NULL);
	    /* add it to mysql. and refresh the list */    
	    g_string_printf (query, "CREATE TABLE `%s` ( `item` INT NOT NULL AUTO_INCREMENT", gtk_entry_get_text(GTK_ENTRY(entry)));
    	    gtk_tree_model_get_iter_first(GTK_TREE_MODEL(as->liststore), &iter);
	    for(i=0;i< (numr);i++){
	    gtk_tree_model_get(GTK_TREE_MODEL(as->liststore), &iter, 1,&name,2, &string,3, &intg,4, &bo, -1);
	    if(string == 1)g_string_append_printf(query, ", `%s` VARCHAR(255)", name);
	    else if(bo == 1) g_string_append_printf(query, ", `%s` tinyint(1)", name);
	    else g_string_append_printf(query, ", `%s` INT(255)", name);
	    gtk_tree_model_iter_next(GTK_TREE_MODEL(as->liststore), &iter);
	    }	 
	    g_string_append(query, ", INDEX (`item`))");
	    if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    close = 0;
		    break;
		}
		
	/* check if there is a selection if yes then check if double clicked on add category */
	    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
	    gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter);
	    if(gtk_tree_path_get_depth(gtk_tree_model_get_path(main_win.index.model, &iter)) == 1){
		parentiter = iter;
		}
	    else{
		gtk_tree_model_get_iter_first(main_win.index.model, &parentiter);
		while(!gtk_tree_store_is_ancestor(main_win.index.treestore, &parentiter, &iter))
		{
		gtk_tree_model_iter_next(main_win.index.model, &parentiter);	
		}
	    }    
	    gtk_tree_model_get(main_win.index.model, &parentiter, 0, &name, -1);
	    g_string_printf(query, "INSERT INTO `%s` VALUES (\"%s\")", name, gtk_entry_get_text(GTK_ENTRY(entry)));
	    if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    close = 0;
		    break;
		}
	    
	    gtk_tree_store_insert (main_win.index.treestore, &iter, &parentiter, 0);
	    gtk_tree_store_set (main_win.index.treestore, &iter,0, gtk_entry_get_text(GTK_ENTRY(entry)), 1,1,-1);
	    
	    gtk_list_store_clear(GTK_LIST_STORE(as->liststore));
	    gtk_entry_set_text(GTK_ENTRY(entry), "");
	    }
	    break;
	case GTK_RESPONSE_CANCEL:
	close = 1;
	break;
	
	default: break;
    	}
    }
    gtk_widget_destroy(dialog);
    g_free(as);

    g_string_free(query, TRUE);
    return;
}

void add_category_add_but(GtkWidget *button, GtkListStore *list){
    GtkTreeIter iter;
    int numr;
    numr = gtk_tree_model_iter_n_children(GTK_TREE_MODEL(list), NULL);
    if(1){
	gtk_list_store_append (list, &iter);
	gtk_list_store_set (list, &iter,0, numr+1, 1, "<enter column name>", 2,1,3,0,4,0,5,1, -1);
    }
    
}

void add_category_remove_but(GtkWidget *button, trees *as){
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(as->treeview));

    /* check if there is a selection if yes then check if double clicked on add category */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(as->treeview));
    if(gtk_tree_selection_get_selected(selection, &model, &iter)){
	gtk_list_store_remove (as->liststore, &iter);
    }    
}


void add_sub_category_edit(GtkCellRendererText *cell, const char *path_string, const char *new_text, trees *as)
	{
	GtkTreePath *path= gtk_tree_path_new_from_string(path_string);
	GtkTreeIter iter;
	gtk_tree_model_get_iter (GTK_TREE_MODEL(as->liststore), &iter, path);
	gtk_list_store_set (GTK_LIST_STORE (as->liststore), &iter, 1,
			    new_text, -1);
	}



void error_dialog(const char *date){
    GtkWidget *dialog;
    dialog = gtk_message_dialog_new(NULL, 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
		"There has an error occured:\n%s", date
		);
    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_destroy(dialog);
}

void delete_sub_category(){
    GtkWidget *dialog;
    GtkTreeSelection *selection;
    GtkTreeIter iter, parentiter;
    gchar *name, *parentn;
    int value;
    GString *query = g_string_new("");
    if(mysql_handle == NULL) return;
    
    /* check if there is a selection if yes then check if double clicked on add category */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter))
	{
	    gtk_tree_model_get(main_win.index.model, &iter, 0, &name,1, &value, -1);
	}
    else value =0;
    
    if(value != 1){
    dialog = gtk_message_dialog_new(GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_WARNING,
		GTK_BUTTONS_CLOSE,
		"Please select an Sub-Category in the index list");
    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_destroy(dialog);
    return;
    }    

    dialog = gtk_message_dialog_new(GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_WARNING,
		GTK_BUTTONS_OK_CANCEL,
		"Are you sure you want to delete the sub-category \"%s\"\nand all it's information?", name);
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_OK:
	    {

	    g_string_printf(query, "drop table `%s`", name);
	    if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    break;
		}
	    
	    gtk_tree_model_get_iter_first(main_win.index.model, &parentiter);
	    while(!gtk_tree_store_is_ancestor(GTK_TREE_STORE(main_win.index.treestore), &parentiter, &iter))
	    {
	    gtk_tree_model_iter_next(main_win.index.model, &parentiter);	
	    }
	    gtk_tree_model_get(main_win.index.model, &parentiter, 0, &parentn, -1);
	    
	    g_string_printf (query, "DELETE FROM `%s` WHERE items=\"%s\"",parentn, name);
	    if(mysql_query(mysql_handle, query->str))
		{
		    error_dialog(mysql_error(mysql_handle));
		    break;
		}
//	    load_index_tree();
	    gtk_tree_store_remove(main_win.index.treestore, &iter);
	    }
	case GTK_RESPONSE_CANCEL:
	default: break;
    	}
    gtk_widget_destroy(dialog);
    g_string_free(query, TRUE);
    return;
}



void add_a_item(){
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    int value = 0, i, close = 0;
    GtkWidget *dialog;
    GtkWidget **entries;
    GtkWidget **labels;
    GtkWidget *table;
    gchar *name;
    GString *query = g_string_new("");
    if(mysql_handle == NULL) return;

    
    /* check if there is a selection if yes then check if double clicked on add category */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));
    if(gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	gtk_tree_model_get(main_win.index.model, &iter, 0, &name, 1, &value, -1);
	}
    if(value != 1)
	{
	error_dialog("You can only add an item in a Sub-Category");	
	return;
	}
    if(ncol < 2){
	error_dialog("There is nothing usefull to add here");	
	return;
    }

    
    entries = g_malloc(ncol * sizeof(GtkWidget));
    for(i=0;i< ncol-1; i++){
     if(main_win.table.types[i+1] == G_TYPE_BOOLEAN)  entries[i] = gtk_check_button_new();
     else if(main_win.table.types[i+1] == G_TYPE_INT)
       entries[i] = gtk_spin_button_new_with_range(0,65535, 1);
     else entries[i] = gtk_entry_new_with_max_length(255);
     }
    
    labels = g_malloc(ncol * sizeof(GtkWidget));
    for(i=0;i< ncol-1; i++) labels[i] = gtk_label_new(gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[i+1])));

    table = gtk_table_new(ncol+3, 4, FALSE);
    gtk_table_set_row_spacings(GTK_TABLE(table), 6);
    gtk_table_set_col_spacings(GTK_TABLE(table), 6);
    for(i=0; i< ncol -1; i++){
	gtk_table_attach(GTK_TABLE(table), labels[i], 0,1, i+1, i+2, GTK_FILL, GTK_FILL, 0,0);
	gtk_table_attach(GTK_TABLE(table), entries[i], 1,2, i+1, i+2, GTK_FILL, GTK_FILL, 0,0);
	if(i+1 < (ncol -1)){
	i++;
	gtk_table_attach(GTK_TABLE(table), labels[i], 2,3, i, i+1, GTK_FILL, GTK_FILL, 0,0);
	gtk_table_attach(GTK_TABLE(table), entries[i], 3,4, i, i+1, GTK_FILL, GTK_FILL, 0,0);
	}
    }

    dialog = gtk_dialog_new_with_buttons("Add an Item", GTK_WINDOW(main_win.window), 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
    		GTK_STOCK_ADD, GTK_RESPONSE_YES,
    		"Add and Close", GTK_RESPONSE_ACCEPT,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, 
		NULL);

    gtk_widget_show_all(table);
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), table);
    gtk_widget_show_all(GTK_DIALOG(dialog)->vbox);	
    while(!close){
    switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	case GTK_RESPONSE_ACCEPT:
	     close = 1;
	case GTK_RESPONSE_YES:
	    {
		gchar *name;
		GtkTreeSelection *selection;
		GtkTreeIter iter;
		int i;
		selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
		gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter); 
		gtk_tree_model_get(main_win.index.model, &iter, 0, &name,  -1);
		g_string_printf (query, "INSERT INTO `%s` VALUES (''", name);
		for(i=0;i< ncol-1;i++)
		    {
			if(main_win.table.types[i+1] == G_TYPE_BOOLEAN) g_string_append_printf(query, ", '%i'", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entries[i])));
			else if (main_win.table.types[i+1] == G_TYPE_INT)  g_string_append_printf(query, ", '%i'", gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(entries[i])));
			else  g_string_append_printf(query, ", \"%s\"", gtk_entry_get_text(GTK_ENTRY(entries[i])));
		    } 
		g_string_append(query, ")");

		/* add it to mysql */
		if(mysql_query(mysql_handle, query->str)){
		    error_dialog(mysql_error(mysql_handle));
		    close = 0;
		    break;	    
		}	
		
		/* reload the table, have to do that.. because of the autoincrement */
		index_changed_test(selection);
		for(i=0; i< ncol-1; i++){
		if(main_win.table.types[i+1] == G_TYPE_BOOLEAN) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entries[i]), FALSE);
		else gtk_entry_set_text(GTK_ENTRY(entries[i]), "");		
		 }
		break;
	     }	
	case GTK_RESPONSE_CANCEL:
	    close = 1;
	    break;
	default: break;
    	}
    }
    
    gtk_widget_destroy(dialog);
    free(entries);
    free(labels);
    g_string_free(query, TRUE);
}

void tree_edited_string(GtkCellRendererText *cell, const char *path_string, const char *new_text, gpointer i)
	{
	gint column = GPOINTER_TO_INT(i);		
	GtkTreeIter iter, iter2;
	char *name;
	gint value;
	GtkTreeSelection *selection;
    	GtkTreePath *path= gtk_tree_path_new_from_string(path_string);
	GString *query = g_string_new("");

	gtk_tree_model_get_iter (main_win.table.model, &iter, path);

	/* now also make the changes in mysql */
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
	gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
	gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);
	/* get the item index name */
	gtk_tree_model_get(main_win.table.model, &iter,0, &value,  -1);

	g_string_printf(query, "UPDATE `%s` set `%s`=\"%s\" WHERE `item`=%i", name, gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[column])) , new_text, value);
	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
	gtk_list_store_set (GTK_LIST_STORE (main_win.table.liststore), &iter, column,
			    new_text, -1);
			    
    gtk_tree_path_free(path);
    g_string_free(query, TRUE);
    }

void tree_edited_int(GtkCellRendererText *cell, const char *path_string, const char *new_text, gpointer i)
	{
	gint column = GPOINTER_TO_INT(i);		
	GtkTreeIter iter, iter2;
	char *name;
	gint value, new_num;
	GtkTreeSelection *selection;
    	GtkTreePath *path= gtk_tree_path_new_from_string(path_string);
	GString *query = g_string_new("");
	
	gtk_tree_model_get_iter (main_win.table.model, &iter, path);
	/* get the item index name */
	gtk_tree_model_get(main_win.table.model, &iter,0, &value,  -1);

	new_num = (gint) atoi(new_text);    
	/* now also make the changes in mysql */
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
	gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
	gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);

	g_string_printf(query, "UPDATE `%s` set `%s`=\"%i\" WHERE `item`=%i", name, gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[column])) , new_num, value);
	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
	gtk_list_store_set (GTK_LIST_STORE (main_win.table.liststore), &iter, column,
			    new_num, -1);
    gtk_tree_path_free(path);
    g_string_free(query, TRUE);
    }



void delete_item(){
	GtkTreeSelection *selection;
	GtkTreeIter iter;
	int i, nsel = 0;
	gchar *name;
	GList *list, *here;
	GString *query = g_string_new("");
	GtkWidget *dialog;
	/* get item number */
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.table.treeview));
        nsel = gtk_tree_selection_count_selected_rows(selection);
/*	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.table.treeview));	*/

/*	if(!gtk_tree_selection_get_selected(selection, &main_win.table.model, &iter)){*/
	if(nsel == 0){
	    error_dialog("You need to select an item to delete it.");
	    g_string_free(query, TRUE);
	    return;	
	    }
	if(nsel > 1){
        dialog = gtk_message_dialog_new(NULL, 
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO,
		"Are you sure you want to delete these %i item's?", nsel
		);
	switch(gtk_dialog_run(GTK_DIALOG(dialog))){
	    case GTK_RESPONSE_YES:
		    gtk_widget_destroy(dialog);
		    break;
	    default:
	        g_string_free(query, TRUE);
		gtk_widget_destroy(dialog);
	    return;	
	    }
	}
	
	
		
	list = gtk_tree_selection_get_selected_rows(selection, &main_win.table.model);
	here = g_list_first(list);
	if(here == NULL){
	g_list_foreach (list,  (GFunc)gtk_tree_path_free, NULL);
	g_list_free (list);
	return;
	}
	
	do{
//	gtk_tree_model_get(main_win.table.model, (list->data), 0, &i, -1);
	gtk_tree_model_get_iter(main_win.table.model, &iter, here->data);
	gtk_tree_model_get(main_win.table.model, &iter, 0, &i, -1);
	/* get table name */
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
	if(!gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	    error_dialog("You need to select an database to delete it. (how the f** did you get here)");
	g_list_foreach (list,  (GFunc)gtk_tree_path_free, NULL);
	g_list_free (list);
	    return;	
	    }
	gtk_tree_model_get(main_win.index.model, &iter, 0, &name, -1);

	
	g_string_printf(query, "DELETE FROM `%s` WHERE item=%i", name, i);

	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	g_list_foreach (list, (GFunc)gtk_tree_path_free, NULL);
	g_list_free (list);
	    return;
	}	
	}while((here = g_list_next(here)) != NULL);
	g_list_foreach (list, (GFunc)gtk_tree_path_free, NULL);
	g_list_free (list);
	index_changed_test(selection);	
	g_string_free(query, TRUE);
}

void empty_option_menu(GtkWidget **items) {
    int i;

    if(items == NULL) {
	items = g_malloc(sizeof(GtkWidget));
	items[0] = NULL;
        return;
     }


  for (i = 0; i < (ncol-1); i++)
    {
      gtk_widget_destroy (items[i]);
      items[i] = NULL;
    }

    items = g_realloc(items, sizeof(GtkWidget));
    items[0] = NULL;
}

void do_quick_search(GtkWidget *entry){
    gchar *name;
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    if(!gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)){
	    error_dialog("You need to select a Category to do a quicksearch");
	    return;	
	    }
    gtk_tree_model_get(main_win.index.model, &iter, 0, &name, -1);

    load_table(name, gtk_entry_get_text(GTK_ENTRY(entry)));
}

/* this one must change */
/* in add_sub_category have to come a category selector first */

int my_popup_handler (GtkWidget *widget, GdkEvent *event, GtkWidget *menu1)
{
    GtkMenu *menu;
    GdkEventButton *event_button;
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    int value = 0;

    if(mysql_handle == NULL) return TRUE;
    
    g_return_val_if_fail (menu1 != NULL, FALSE);
    g_return_val_if_fail (GTK_IS_MENU (menu1), FALSE);
    g_return_val_if_fail (event != NULL, FALSE);
	  
    /* The "menu" is the menu that was supplied when 
     * g_signal_connect_swapped() was called.
      */
    menu = GTK_MENU (menu1);
    /* check if usefull item is selected */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    if(!gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter))
	{
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Category"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Sub-Category"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Sub-Category"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Category"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Sub-Category"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Category"), FALSE);    	
	}
    else{
	gtk_tree_model_get(main_win.index.model, &iter, 1, &value, -1);
	if(value == 0)
	    {
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Sub-Category"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Sub-Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Category"), TRUE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Sub-Category"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Category"), TRUE);    	
	}
	else if(value == 1)
	    {
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Sub-Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Sub-Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Category"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Sub-Category"), TRUE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Category"), FALSE);    	
	    }
	else if(value == 3)
	    {
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Sub-Category"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Sub-Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Category"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Sub-Category"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Category"), FALSE);    	
	    }
	else{
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Category"), TRUE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Sub-Category"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/New Sub-Category"), FALSE);    	
	    gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Delete Category"), FALSE);    
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Sub-Category"), FALSE);    	
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.index.item_factory, "/Edit Category"), FALSE);    	
	    }	
	
	}
    
    if (event->type == /*GDK_BUTTON_PRESS*/GDK_BUTTON_RELEASE)
          {
	    event_button = (GdkEventButton *) event;
	    if (event_button->button == 3)
	        {
		      gtk_menu_popup (menu, NULL, NULL, NULL, NULL, 
	    	      event_button->button, event_button->time);
	              return TRUE;
	        }
		
	    }
    return FALSE;
  }

int table_popup_handler (GtkWidget *widget, GdkEvent *event, GtkWidget *menu1)
{
    GtkMenu *menu;
    GdkEventButton *event_button;
    GtkTreeSelection *selection;
    GtkTreeIter iter;
    int value, nsel;
    if(mysql_handle == NULL) return TRUE;

    
    g_return_val_if_fail (menu1 != NULL, FALSE);
    g_return_val_if_fail (GTK_IS_MENU (menu1), FALSE);
    g_return_val_if_fail (event != NULL, FALSE);
	  

    menu = GTK_MENU (menu1);

    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
    if(!gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter)) return FALSE;
    gtk_tree_model_get(main_win.index.model, &iter, 1, &value, -1);
    if(value != 1) return TRUE;    

    /* check if usefull item is selected */
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.table.treeview));	

    nsel = gtk_tree_selection_count_selected_rows(selection);

/*    if(!gtk_tree_selection_get_selected(selection, &main_win.table.model, &iter)){*/
    if(nsel == 0){
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.table.item_factory, "/Delete"), FALSE);    
	}
    else{
	gtk_widget_set_sensitive(gtk_item_factory_get_item(main_win.table.item_factory, "/Delete"), TRUE);    
	}
    
    if (event->type == GDK_BUTTON_RELEASE)
          {
	    event_button = (GdkEventButton *) event;
	    if (event_button->button == 3)
	        {
		      gtk_menu_popup (menu, NULL, NULL, NULL, NULL, 
	    	      event_button->button, event_button->time);
	              return FALSE;
	        }
	    else if(event_button->button == 1)
		{
		 
		
		}
	    }
    return FALSE;
  }

void quit_program() {
    cfp_write();
    gtk_main_quit();
    gtk_exit(0);
}

/*
 * can't get the size and geometry of the window when using the wm's close
 * button inside of quit_program(). ??
 */
int window_configure_event(GtkWidget *widget, gpointer data) {
     /*
      * set the values regardless. a user might move the window around,
      * then see the option to save geometry. cfp_write() currently tests
      * for main_info.save_posize.
      */

     gtk_window_get_size(GTK_WINDOW(widget),
         &main_info.width, &main_info.height);

     gtk_window_get_position(GTK_WINDOW(widget),
         &main_info.x, &main_info.y);

     return(0);
}

void
fixed_toggled (GtkCellRendererToggle *cell, gchar *path_str, gpointer data)
		   {
    GtkTreeSelection *selection;
     GtkTreeIter  iter, iter2;
     GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
     GString *query = g_string_new("");
       gboolean fixed;
       int column = GPOINTER_TO_INT(data);
       int value;
       gchar *name;
			   
     /* get toggled iter */
     gtk_tree_model_get_iter (main_win.table.model, &iter, path);
     gtk_tree_model_get (main_win.table.model, &iter, column, &fixed, -1);
		 
   /* do something with the value */
	     fixed ^= 1;
			     
       /* set new value */
         gtk_list_store_set (main_win.table.liststore, &iter, column, fixed, -1);
					 
   /* clean up */
     gtk_tree_path_free (path);
     
	/* now also make the changes in mysql */
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(main_win.index.treeview));	
	gtk_tree_selection_get_selected(selection, &main_win.index.model, &iter2); 
	gtk_tree_model_get(main_win.index.model, &iter2,0, &name,  -1);
	/* get the item index name */
	gtk_tree_model_get(main_win.table.model, &iter,0, &value,  -1);

	g_string_printf(query, "UPDATE `%s` set `%s`=\"%i\" WHERE `item`=%i", name, gtk_tree_view_column_get_title(GTK_TREE_VIEW_COLUMN(main_win.table.columns[column])) , fixed, value);
	if(mysql_query(mysql_handle, query->str)){
	    error_dialog(mysql_error(mysql_handle));
	    return;
	}	
			    

    g_string_free(query, TRUE);
     
 
     }




int
add_sub_toggled_string (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data)
  {
 GtkTreeModel *model = (GtkTreeModel *)data;
   GtkTreeIter  iter;
 GtkTreePath *path = gtk_tree_path_new_from_string (path_str);

    gtk_tree_model_get_iter (model, &iter, path);
	gtk_list_store_set (GTK_LIST_STORE (model), &iter, 2, TRUE, 3, FALSE, 4, FALSE, -1);
     gtk_tree_path_free (path);
     return 0;
 }


int
add_sub_toggled_int (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data)
  {
 GtkTreeModel *model = (GtkTreeModel *)data;
   GtkTreeIter  iter;
 GtkTreePath *path = gtk_tree_path_new_from_string (path_str);

    gtk_tree_model_get_iter (model, &iter, path);
	gtk_list_store_set (GTK_LIST_STORE (model), &iter, 2, FALSE, 3, TRUE, 4, FALSE, -1);
     gtk_tree_path_free (path);
     return 0;
 }

int
add_sub_toggled_bool (GtkCellRendererToggle *cell, gchar *path_str, gpointer  data)
  {
 GtkTreeModel *model = (GtkTreeModel *)data;
   GtkTreeIter  iter;
 GtkTreePath *path = gtk_tree_path_new_from_string (path_str);

    gtk_tree_model_get_iter (model, &iter, path);
	gtk_list_store_set (GTK_LIST_STORE (model), &iter, 2, FALSE, 3, FALSE, 4, TRUE, -1);
     gtk_tree_path_free (path);
     return 0;
 }
