
typedef struct {
    GtkWidget *vbox;
    GtkWidget *label, *tlabel;
    GtkWidget *table;
    GtkWidget **labels;
    GtkWidget **entries;
    GtkWidget **buttons;
    }npage;
    
typedef struct {
    gchar hostname[256];
    gint port;
    gchar password[256];
    gchar username[256];
    gchar database[256];
    gboolean auto_connect;
    gboolean save_settings;
    gboolean save_posize;
    gint height, width, x, y;
}info;
extern info main_info;

typedef struct {
    GtkWidget *viewport;
    GtkTreeStore *treestore;
    GtkListStore *liststore;
    GtkWidget *treeview;
    GtkTreeViewColumn **columns;
    GtkItemFactory *item_factory;
    GtkTreeModel *model;
    GtkWidget *menu;
    GType *types;
    }trees;

typedef struct {
    GtkWidget *window, *dialog;
    GtkWidget *hbox, *vbox;
    GtkAccelGroup *accel_group;
    GtkItemFactory *item_factory;
    GtkWidget *statusbar;
    GtkWidget *progress;
    GtkWidget *hpaned;
    trees  index;
    trees table;
    GtkWidget *toolbar;
    GtkWidget *notebook;
    /* pref part */
    npage server;
    GtkWidget *button;
    /* import part, yes I sthould split it*/
    GtkWidget **entry;
    gchar *name;
    }windows;
    
/* gui.c */    
void create_main_window();
extern windows main_win;
void pref_screen();

extern GtkWidget *qs_menu, *sentry;
extern GtkWidget *qs_option;
extern GtkWidget **qs_sel;



/* callback .c */
extern int ncol;

int index_changed_test(GtkTreeSelection *selection);
void load_index_tree();
void connect_to_dbase();
void quit_connection();
void close_prefwin(GtkWidget *button, windows *pref_win);
void add_a_category();
void handle_index_double_click_signal();
void delete_a_category();
void add_sub_category();
void edit_sub_category();
void error_dialog(const char *date);
void delete_sub_category();
void add_a_item();
void delete_item();
void do_quick_search(GtkWidget *entry);
int my_popup_handler (GtkWidget *widget, GdkEvent *event, GtkWidget *menu1);
int table_popup_handler (GtkWidget *widget, GdkEvent *event, GtkWidget *menu1);
void quit_program();
int window_configure_event(GtkWidget *widget, gpointer data);
void load_table(char *name, const char *search);


extern MYSQL *mysql_handle;
/* save_value */
void cfp_write();
void cfp_read();

/* export */
void export_file_selector();

/* import */
void import_file_selector();

/* category.c */
void edit_category_title();

/* subcategory.c */
void empty_sub_category();

/* items.c */
void edit_view_a_item();


/* some value's info 
Category = char[128]










*/

